opal/util/opal_environ.h File Reference.TH "opal/util/opal_environ.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
opal/util/opal_environ.h \- Generic helper routines for environment manipulation. 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br

.SS "Functions"

.in +1c
.ti -1c
.RI "OMPI_DECLSPEC char ** \fBopal_environ_merge\fP (char **minor, char **major)"
.br
.RI "\fIMerge two environ-like arrays into a single, new array, ensuring that there are no duplicate entries. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_setenv\fP (const char *name, const char *value, bool overwrite, char ***env)"
.br
.RI "\fIPortable version of setenv(3), allowing editing of any environ-like array. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_unsetenv\fP (const char *name, char ***env)"
.br
.RI "\fIPortable version of unsetenv(3), allowing editing of any environ-like array. \fP"
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "OMPI_DECLSPEC char ** \fBopal_environ\fP"
.br
.RI "\fISo that others don't have to declare it. \fP"
.in -1c
.SH "Detailed Description"
.PP 
Generic helper routines for environment manipulation. 


.SH "Function Documentation"
.PP 
.SS "OMPI_DECLSPEC char** opal_environ_merge (char ** minor, char ** major)"
.PP
Merge two environ-like arrays into a single, new array, ensuring that there are no duplicate entries. 
.PP
\fBParameters:\fP
.RS 4
\fIminor\fP Set 1 of the environ's to merge 
.br
\fImajor\fP Set 2 of the environ's to merge 
.RE
.PP
\fBReturn values:\fP
.RS 4
\fINew\fP array of environ
.RE
.PP
Merge two environ-like arrays into a single, new array, ensuring that there are no duplicate entires. If there are duplicates, entries in the \fImajor\fP array are favored over those in the \fIminor\fP array.
.PP
Both \fImajor\fP and \fIminor\fP are expected to be argv-style arrays (i.e., terminated with a NULL pointer).
.PP
The array that is returned is an unencumbered array that should later be freed with a call to \fBopal_argv_free()\fP.
.PP
Either (or both) of \fImajor\fP and \fIminor\fP can be NULL. If one of the two is NULL, the other list is simply copied to the output. If both are NULL, NULL is returned. 
.SS "OMPI_DECLSPEC int opal_setenv (const char * name, const char * value, bool overwrite, char *** env)"
.PP
Portable version of setenv(3), allowing editing of any environ-like array. 
.PP
\fBParameters:\fP
.RS 4
\fIname\fP String name of the environment variable to look for 
.br
\fIvalue\fP String value to set 
.br
\fIoverwrite\fP Whether to overwrite any existing value with the same name 
.br
\fIenv\fP The environment to use
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_ERR_OUT_OF_RESOURCE\fP If internal malloc() fails. 
.br
\fIOMPI_EXISTS\fP If the name already exists in \fIenv\fP and \fIoverwrite\fP is false (and therefore the \fIvalue\fP was not saved in \fIenv\fP) 
.br
\fIOMPI_SUCESS\fP If the value replaced another value or is appended to \fIenv\fP.
.RE
.PP
\fIenv\fP is expected to be a NULL-terminated array of pointers (argv-style). Note that unlike some implementations of putenv(3), if \fIvalue\fP is insertted in \fIenv\fP, it is copied. So the caller can modify/free both \fIname\fP and \fIvalue\fP after \fBopal_setenv()\fP returns.
.PP
The \fIenv\fP array will be grown if necessary.
.PP
It is permissable to invoke this function with the system-defined \fIenviron\fP variable. For example:
.PP
.PP
.nf
   extern char **environ;
   opal_setenv('foo', 'bar', true, &environ);
.fi
.PP
.PP
NOTE: If you use the real environ, \fBopal_setenv()\fP will turn around and perform putenv() to put the value in the environment. This may very well lead to a memory leak, so its use is strongly discouraged.
.PP
It is also permissable to call this function with an empty \fIenv\fP, as long as it is pre-initialized with NULL:
.PP
.PP
.nf
   char **my_env = NULL;
   opal_setenv('foo', 'bar', true, &my_env);
.fi
.PP
 
.SS "OMPI_DECLSPEC int opal_unsetenv (const char * name, char *** env)"
.PP
Portable version of unsetenv(3), allowing editing of any environ-like array. 
.PP
\fBParameters:\fP
.RS 4
\fIname\fP String name of the environment variable to look for 
.br
\fIenv\fP The environment to use
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_ERR_OUT_OF_RESOURCE\fP If an internal malloc fails. 
.br
\fIOMPI_ERR_NOT_FOUND\fP If \fIname\fP is not found in \fIenv\fP. 
.br
\fIOMPI_SUCCESS\fP If \fIname\fP is found and successfully deleted.
.RE
.PP
If \fIname\fP is found in \fIenv\fP, the string corresponding to that entry is freed and its entry is eliminated from the array. 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
